Public Class DataGridExample
    Inherits System.Web.UI.Page

#Region " Properties "
    Protected Property SortField() As String
        Get
            Dim strSortField As String
            Try
                strSortField = Session("SortField").ToString
                If strSortField = "" Then
                    Return "au_lname"
                Else : Return strSortField
                End If
            Catch
                Return "au_lname"
            End Try
        End Get

        Set(ByVal Value As String)
            Session("SortField") = Value
        End Set
    End Property

    Protected Property SortAscending() As Boolean
        Get
            Dim boolCurrentSort As Boolean
            Try
                boolCurrentSort = CType(Session("SortAscending").ToString, Boolean)
                Return boolCurrentSort
            Catch
                Return True
            End Try
        End Get

        Set(ByVal Value As Boolean)
            Session("SortAscending") = Value
        End Set
    End Property
#End Region

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.AuthorsDataSet = New VSM072004.authorsDataSet
        Me.SqlDataAdapter1 = New System.Data.SqlClient.SqlDataAdapter
        Me.SqlDeleteCommand1 = New System.Data.SqlClient.SqlCommand
        Me.SqlConnection1 = New System.Data.SqlClient.SqlConnection
        Me.SqlInsertCommand1 = New System.Data.SqlClient.SqlCommand
        Me.SqlSelectCommand1 = New System.Data.SqlClient.SqlCommand
        Me.SqlUpdateCommand1 = New System.Data.SqlClient.SqlCommand
        CType(Me.AuthorsDataSet, System.ComponentModel.ISupportInitialize).BeginInit()
        '
        'AuthorsDataSet
        '
        Me.AuthorsDataSet.DataSetName = "authorsDataSet"
        Me.AuthorsDataSet.Locale = New System.Globalization.CultureInfo("en-US")
        '
        'SqlDataAdapter1
        '
        Me.SqlDataAdapter1.DeleteCommand = Me.SqlDeleteCommand1
        Me.SqlDataAdapter1.InsertCommand = Me.SqlInsertCommand1
        Me.SqlDataAdapter1.SelectCommand = Me.SqlSelectCommand1
        Me.SqlDataAdapter1.TableMappings.AddRange(New System.Data.Common.DataTableMapping() {New System.Data.Common.DataTableMapping("Table", "authors", New System.Data.Common.DataColumnMapping() {New System.Data.Common.DataColumnMapping("au_lname", "au_lname"), New System.Data.Common.DataColumnMapping("au_fname", "au_fname"), New System.Data.Common.DataColumnMapping("au_id", "au_id"), New System.Data.Common.DataColumnMapping("phone", "phone"), New System.Data.Common.DataColumnMapping("address", "address"), New System.Data.Common.DataColumnMapping("city", "city"), New System.Data.Common.DataColumnMapping("state", "state"), New System.Data.Common.DataColumnMapping("zip", "zip"), New System.Data.Common.DataColumnMapping("contract", "contract")})})
        Me.SqlDataAdapter1.UpdateCommand = Me.SqlUpdateCommand1
        '
        'SqlDeleteCommand1
        '
        Me.SqlDeleteCommand1.CommandText = "DELETE FROM authors WHERE (au_id = @Original_au_id) AND (address = @Original_addr" & _
        "ess OR @Original_address IS NULL AND address IS NULL) AND (au_fname = @Original_" & _
        "au_fname) AND (au_lname = @Original_au_lname) AND (city = @Original_city OR @Ori" & _
        "ginal_city IS NULL AND city IS NULL) AND (contract = @Original_contract) AND (ph" & _
        "one = @Original_phone) AND (state = @Original_state OR @Original_state IS NULL A" & _
        "ND state IS NULL) AND (zip = @Original_zip OR @Original_zip IS NULL AND zip IS N" & _
        "ULL)"
        Me.SqlDeleteCommand1.Connection = Me.SqlConnection1
        Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_au_id", System.Data.SqlDbType.VarChar, 11, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "au_id", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_address", System.Data.SqlDbType.VarChar, 40, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "address", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_au_fname", System.Data.SqlDbType.VarChar, 20, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "au_fname", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_au_lname", System.Data.SqlDbType.VarChar, 40, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "au_lname", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_city", System.Data.SqlDbType.VarChar, 20, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "city", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_contract", System.Data.SqlDbType.Bit, 1, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "contract", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_phone", System.Data.SqlDbType.VarChar, 12, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "phone", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_state", System.Data.SqlDbType.VarChar, 2, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "state", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_zip", System.Data.SqlDbType.VarChar, 5, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "zip", System.Data.DataRowVersion.Original, Nothing))
        '
        'SqlConnection1
        '
        Me.SqlConnection1.ConnectionString = "workstation id=DOMINION;packet size=4096;integrated security=SSPI;data source=DOM" & _
        "INION;persist security info=False;initial catalog=pubs"
        '
        'SqlInsertCommand1
        '
        Me.SqlInsertCommand1.CommandText = "INSERT INTO authors(au_lname, au_fname, au_id, phone, address, city, state, zip, " & _
        "contract) VALUES (@au_lname, @au_fname, @au_id, @phone, @address, @city, @state," & _
        " @zip, @contract); SELECT au_lname, au_fname, au_id, phone, address, city, state" & _
        ", zip, contract FROM authors WHERE (au_id = @au_id)"
        Me.SqlInsertCommand1.Connection = Me.SqlConnection1
        Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@au_lname", System.Data.SqlDbType.VarChar, 40, "au_lname"))
        Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@au_fname", System.Data.SqlDbType.VarChar, 20, "au_fname"))
        Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@au_id", System.Data.SqlDbType.VarChar, 11, "au_id"))
        Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@phone", System.Data.SqlDbType.VarChar, 12, "phone"))
        Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@address", System.Data.SqlDbType.VarChar, 40, "address"))
        Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@city", System.Data.SqlDbType.VarChar, 20, "city"))
        Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@state", System.Data.SqlDbType.VarChar, 2, "state"))
        Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@zip", System.Data.SqlDbType.VarChar, 5, "zip"))
        Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@contract", System.Data.SqlDbType.Bit, 1, "contract"))
        '
        'SqlSelectCommand1
        '
        Me.SqlSelectCommand1.CommandText = "SELECT au_lname, au_fname, au_id, phone, address, city, state, zip, contract FROM" & _
        " authors"
        Me.SqlSelectCommand1.Connection = Me.SqlConnection1
        '
        'SqlUpdateCommand1
        '
        Me.SqlUpdateCommand1.CommandText = "UPDATE authors SET au_lname = @au_lname, au_fname = @au_fname, au_id = @au_id, ph" & _
        "one = @phone, address = @address, city = @city, state = @state, zip = @zip, cont" & _
        "ract = @contract WHERE (au_id = @Original_au_id) AND (address = @Original_addres" & _
        "s OR @Original_address IS NULL AND address IS NULL) AND (au_fname = @Original_au" & _
        "_fname) AND (au_lname = @Original_au_lname) AND (city = @Original_city OR @Origi" & _
        "nal_city IS NULL AND city IS NULL) AND (contract = @Original_contract) AND (phon" & _
        "e = @Original_phone) AND (state = @Original_state OR @Original_state IS NULL AND" & _
        " state IS NULL) AND (zip = @Original_zip OR @Original_zip IS NULL AND zip IS NUL" & _
        "L); SELECT au_lname, au_fname, au_id, phone, address, city, state, zip, contract" & _
        " FROM authors WHERE (au_id = @au_id)"
        Me.SqlUpdateCommand1.Connection = Me.SqlConnection1
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@au_lname", System.Data.SqlDbType.VarChar, 40, "au_lname"))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@au_fname", System.Data.SqlDbType.VarChar, 20, "au_fname"))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@au_id", System.Data.SqlDbType.VarChar, 11, "au_id"))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@phone", System.Data.SqlDbType.VarChar, 12, "phone"))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@address", System.Data.SqlDbType.VarChar, 40, "address"))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@city", System.Data.SqlDbType.VarChar, 20, "city"))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@state", System.Data.SqlDbType.VarChar, 2, "state"))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@zip", System.Data.SqlDbType.VarChar, 5, "zip"))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@contract", System.Data.SqlDbType.Bit, 1, "contract"))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_au_id", System.Data.SqlDbType.VarChar, 11, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "au_id", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_address", System.Data.SqlDbType.VarChar, 40, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "address", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_au_fname", System.Data.SqlDbType.VarChar, 20, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "au_fname", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_au_lname", System.Data.SqlDbType.VarChar, 40, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "au_lname", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_city", System.Data.SqlDbType.VarChar, 20, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "city", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_contract", System.Data.SqlDbType.Bit, 1, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "contract", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_phone", System.Data.SqlDbType.VarChar, 12, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "phone", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_state", System.Data.SqlDbType.VarChar, 2, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "state", System.Data.DataRowVersion.Original, Nothing))
        Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_zip", System.Data.SqlDbType.VarChar, 5, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "zip", System.Data.DataRowVersion.Original, Nothing))
        CType(Me.AuthorsDataSet, System.ComponentModel.ISupportInitialize).EndInit()

    End Sub
    Protected WithEvents Label1 As System.Web.UI.WebControls.Label
    Protected WithEvents pubsDataGrid As System.Web.UI.WebControls.DataGrid
    Protected WithEvents AuthorsDataSet As VSM072004.authorsDataSet
    Protected WithEvents SqlDataAdapter1 As System.Data.SqlClient.SqlDataAdapter
    Protected WithEvents SqlSelectCommand1 As System.Data.SqlClient.SqlCommand
    Protected WithEvents SqlInsertCommand1 As System.Data.SqlClient.SqlCommand
    Protected WithEvents SqlUpdateCommand1 As System.Data.SqlClient.SqlCommand
    Protected WithEvents SqlDeleteCommand1 As System.Data.SqlClient.SqlCommand
    Protected WithEvents SqlConnection1 As System.Data.SqlClient.SqlConnection

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here
        If Not IsPostBack Then
            BindDataGrid()
        End If
    End Sub

    Protected Sub DataGrid1_ItemDataBound(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles pubsDataGrid.ItemDataBound
        Dim strSortField As String
        Dim boolSortAscending As Boolean
        Dim lblSortArrow As Label
        Dim Cell As TableCell
        Dim strOldString As String

        ' If it is a header row item, then make sure we put the right sort characters
        ' If it is a data item, then we have got some formatting to do
        Select Case e.Item.ItemType

            Case ListItemType.Item
            Case ListItemType.AlternatingItem

            Case ListItemType.Header
                ' Add a little up/down arrow next to the sort field to indicate which
                ' way the data is being sorted
                strSortField = SortField
                boolSortAscending = SortAscending
                lblSortArrow = New Label
                lblSortArrow.Font.Name = "Webdings"
                If SortAscending Then
                    lblSortArrow.Text = "6"
                Else
                    lblSortArrow.Text = "5"
                End If
                Select Case strSortField
                    Case "au_lname"
                        Cell = e.Item.Cells(0)
                    Case ""
                        ' If blank, then use the default sort (au_lname)
                        Cell = e.Item.Cells(0)

                    Case "au_fname"
                        Cell = e.Item.Cells(1)

                    Case "city"
                        Cell = e.Item.Cells(3)

                    Case "state"
                        Cell = e.Item.Cells(4)

                    Case "zip"
                        Cell = e.Item.Cells(5)

                End Select

                Try
                    Cell.Controls.Add(lblSortArrow)
                Catch

                End Try

            Case ListItemType.Footer

            Case ListItemType.Pager

            Case Else

        End Select

    End Sub

    Private Sub pubsDataGrid_EditCommand(ByVal sender As System.Object, ByVal e As DataGridCommandEventArgs) Handles pubsDataGrid.EditCommand
        ' Mark the selected item ready for edits
        pubsDataGrid.EditItemIndex = e.Item.ItemIndex
        BindDataGrid()
    End Sub

    Private Sub pubsDataGrid_CancelCommand(ByVal sender As System.Object, ByVal e As DataGridCommandEventArgs) Handles pubsDataGrid.CancelCommand
        ' Cancel the edits
        pubsDataGrid.EditItemIndex = -1
        BindDataGrid()
    End Sub

    Private Sub pubsDataGrid_DeleteCommand(ByVal sender As System.Object, ByVal e As DataGridCommandEventArgs) Handles pubsDataGrid.DeleteCommand
        ' Put your delete code here

        ' Reset the selected index
        pubsDataGrid.EditItemIndex = -1
        BindDataGrid()
    End Sub

    Private Sub pubsDataGrid_UpdateCommand(ByVal sender As System.Object, ByVal e As DataGridCommandEventArgs) Handles pubsDataGrid.UpdateCommand
        ' Put your update code here

        ' Reset the selected index
        pubsDataGrid.EditItemIndex = -1
        BindDataGrid()
    End Sub

    Private Sub pubsDataGrid_Sort(ByVal sender As System.Object, ByVal e As DataGridSortCommandEventArgs) Handles pubsDataGrid.SortCommand
        ' Save the old sort field
        Dim strCurrentSortField As String = SortField

        ' Save the new sort expression (name of the Data Grid field)
        SortField = e.SortExpression.ToString()

        If (strCurrentSortField.Equals(SortField)) Then
            SortAscending = Not SortAscending
        Else
            SortAscending = True
        End If

        ' Change to the initial page so that the new sort starts displaying at Page 0
        pubsDataGrid.CurrentPageIndex = 0
        BindDataGrid()

    End Sub
    Private Sub pubsDataGrid_Page(ByVal sender As System.Object, ByVal e As DataGridPageChangedEventArgs) Handles pubsDataGrid.PageIndexChanged
        ' Change the current data grid page
        pubsDataGrid.CurrentPageIndex = e.NewPageIndex
        ' Reset the selected index
        pubsDataGrid.EditItemIndex = -1
        BindDataGrid()
    End Sub

    Private Sub BindDataGrid()
        Dim dt As DataTable
        Dim dv As DataView
        Dim strSort As String

        ' Set a pointer to the data table
        SqlDataAdapter1.Fill(AuthorsDataSet)
        dt = AuthorsDataSet.Tables("Authors")

        ' Create a new view space
        dv = New DataView(dt)

        ' Set the sort of the view equal to what the user selected
        strSort = SortField
        If (SortAscending = False) Then
            strSort += " desc"
        Else
            strSort += " asc"
        End If

        dv.Sort = strSort
        pubsDataGrid.DataSource = dv
        pubsDataGrid.DataBind()
    End Sub
End Class
